;                       /|
;                      //|.
;                     //_| .
;                 __ // /| .
;                /_ \/\__|. 
;                \\_/  _/|_
;                .g.e.n.d.a.
;
;______________________________________________________
;
;
;               nabuchodonosor 256b
;
;______________________________________________________
;
;	CODE:	        svoy
;______________________________________________________
;
;     Silly Venture 2017 256b intro
;     After Party Version by JAC!
;______________________________________________________
; tomaswoj@gmail.com
; http://pl.linkedin.com/in/tomaswoj
; Cracow
; Was original"nabuchodonosor_v08_snd.asm"
	opt h+
	
	org $2000
xcal_l	equ $d8 ; xcalcd LSB
ycal_l	equ $d9
curad_h equ $e1 ; current screen line address
curad_l	equ $e2
xpix	equ $f0
xcalcd	equ $f2
yrow	equ $f1
ycalcd	equ $f3
frmcnt	equ $f4

	lda #12		; set multicolor text mode			
	jsr $ef9c
	sty 623   	;<Y>:=1 right sprite priorities (over playfield)

; sprites setup
	lda #$2e
	sta $2f4 ; charset at $$2c00
	sta 709
	sta $22f ; wide, PM enabled
	sta $d01d ; reuse that to enable players
	sta $d407 ; reuse that to set PM memory page - $2c00

frame:
	sty yrow ; set yrow to 0 on new frame	
	lda 88 ;lda fm1_h
	sta curad_h	
	lda 89 ;lda fm1_l
	sta curad_l	
lines: 
	ldy #39 ; 39 pixels			 
pixels:	
	ldx #1 ; (index1: ycalcd=yrow-8)
	lda yrow
	jsr subs	
	tya
	sta xpix
	dex; -> x=0
	jsr subs ; (index0: xcalcd = xpix - 8)
	txa ; POT
	pha ; use stack for xcal_l
	;stx xcal_l ;(0)
	stx ycal_l ;(0) 
	ldx frmcnt ; use frame count as depth offset (increasing)
cast: 
	;lda xcal_l   ; if (distx>22 || disty>16) break,  just check proper bits from high parts of xcal/ycal
	pla
	pha ; we are polluting the stack, but we don't know if we reach next pha down
	cmp #64 ; 2c	
	bcs beyo
	adc xcalcd ; 3c        ; xcalc+=xcalcd	
	;sta xcal_l
	pha	 
	lda ycal_l	
	cmp #64
	bcs beyo
	adc ycalcd   ; ycalc+=ycalcd
	sta ycal_l ; 3c
	inx	
        bne cast        
beyo:	 
	; depthmap = (depth^distx^disty)/16
	; bit shifting magic :)
	;lda xcal_l
	pla
	eor ycal_l
	lsr
	sta xcal_l		
	txa ; depth into accu	, 2c
	lse xcal_l ; illegal, shift right xcal_l, then eor with accu, one lsr above shaved
	lsr
	lsr
	lsr
	sta (curad_h),Y
	; engine color
	sta 706
	; engine sounds
	ora #%1101000	
	sta $D201 ; ctrl
	sta $D200		
	dey
	bne pixels ; if no pixels left go to next line
	; update addresses by 40bytes (next line
	clc
	lda curad_h
	adc #40	;offset
	sta curad_h	
	bcc nocarry ; if no carry - skip add
	inc curad_l	
nocarry:
	clc
	lda #24
	isb yrow ; (inc memory, then subs from accumulator - illegal, but how nice! :) 2 bytes less
	bne lines	
	isb frmcnt ; inc frmcnt, then subs from accumulator
	bne frame ; heh, this will go to frame until frmcnt reaches 255	
		
subs:			;IN: <X>:=0/1
	sbc #8
        bcs skipneg	; we want offset to be > 0
	eor #$FF	; negation if needed
	;adc #1		; looks like has no effect
skipneg:		
	sta xcalcd,x		
	rts
codeend

; dither table      
      ;org $2800
      ;org $2820
      ;org $2828 ; looks nice       	  	  	
      org $2c2f ; better ending
chars dta b(68,0,17,0,68,0,17,0)
      dta b(68,17,0,68,17,0,68,17)
      dta b(68,17,85,68,17,85,68,17)
      dta b(17,85,68,85,17,85,68,85)
      dta b(85,85,85,85,85,85,85,85)
      dta b(153,85,102,85,153,85,102,85)
      ;dta b(153,102,85,153,102,85,153,102)
      ;dta b(153,102,170,153,102,170,153,102)
      ;dta b(102,170,153,170,102,170,153,170)
      ;dta b(170,170,170,170,170,170,170,170)
      ;dta b(238,170,187,170,238,170,187,170)
      ;dta b(238,187,170,238,187,170,238,187)
      ;dta b(238,187,255,238,187,255,238,187)
      ;dta b(255,255,255,255,255,255,255,255)

; nabuchodonosor ship

	;org $3259
	org $2e59	
sp1	dta b($f,$1f,$3f,$3f,$7f,$7f,$7f,$e4,$c4,$ff)
	;org $32da
	org $2eda
sp2	dta b($c0, $e0, $f8, $fc, $fe, $93, $93, $fe)
	;org $335f
	org $2f5f
sp3	dta b($6,$36,$30) ; POT1

	org 704
	.byte $82,$82 ; ship color color ; POT2	
	
	org $d000
	.byte $60, $70, $68
	org $d008
	.byte 1,1,1

	run $2000
