;
;	>>> SillyPack - Reharden Loader by JAC! <<<
;
;	This file creates a packaed loader based on the
;	full memory dump of the original Reharden demo.
;
;	Uncomment this for the initial split
;	.get 'REHARDEN-$0000-$FFFF.bin',$200,$fe00
;	.sav "REHARDEN-$0200-$BFFF.bin",0,$be00
;	.sav "REHARDEN-$C000-$CFFF.bin",$be00,$1000
;	.sav "REHARDEN-$D800-$FF0A.bin",$ce00+$800,$270b
;	The run the makefile to create the packed files.

	icl "equates.asm"

	org $2000
	.byte 'Reharden by HARD for Sillyventure 2k17,',155,13,10,0
	.byte 'DOS 2.5 compatible version by JAC! on 2018-05-10.',155,13,10,0

	org $2000

screen_bytes	= $50
loader_screen	= $60				;$50 bytes
loader_dlist	= loader_screen+screen_bytes	;$4e bytes

	.print .len loader_dlist_template
init
	ldx #$00
cpldl	lda loader_dlist_template,x
	sta loader_dlist,x
	inx
	cpx #.len loader_dlist_template
	bne cpldl

	lda #$00
	tax
flscr	cpx #8
	scs
	sta $00,x		;Clear char 0
	sta loader_screen,x	;Clear screen
	inx
	cpx #screen_bytes
	bne flscr

	ora #$80
	sta loader_screen+42

	jsr wait

	lda #$22
	sta SDMCTL

	lda #>loader_screen
	sta CHBAS ;all we need is an empty space character

	lda #<loader_dlist
	sta SDLSTL
	lda #>loader_dlist
	sta SDLSTH
	
	lda #$00
	sta COLOR4
	lda #$CA
	sta COLOR1
	lda #$94
	sta COLOR2

	lda #$ff
	sta PORTB
	STA COLDST

	.proc wait
	lda RTCLOK+2
loop	cmp RTCLOK+2
	beq loop
	rts
	.endp

	.print "Loader list template size is ", .len loader_dlist_template
	.local loader_dlist_template
	.byte $70, $70, $70
	.byte $42, <(loader_screen+40), >(loader_screen+40)
	.rept 23
	.byte $42, <loader_screen, >loader_screen
	.endr
	.byte $41, <loader_dlist, >loader_dlist
	.endl
loader_end

	ini init

	org $2100
	.proc unpack
	sei
	lda #0
	sta IRQEN
	sta NMIEN
	lda #$fe
	sta PORTB
	jsr unlz4
	lda #$ff
	sta PORTB
	lda #$40
	sta NMIEN
	lda #$c0
	sta IRQEN
	cli
	rts

	icl "LZ4.asm"
	
	.endp
unpack_end

	org $2200
	.proc init_c000
	mwa #source unpack.unlz4.source
	mwa #$c000  unpack.unlz4.dest
	jmp unpack

source	ins "REHARDEN-$C000-$CFFF.bin.lz4",+$0b
	.endp

	ini init_c000

	org $2200
	.proc init_d800
	mwa #source unpack.unlz4.source
	mwa #$d800  unpack.unlz4.dest
	jmp unpack

source	ins "REHARDEN-$D800-$FF0A.bin.lz4",+$0b
	.endp

	ini init_d800

	.proc init_0200
?filesize =.filesize 'REHARDEN-$0200-$BFFF-Fix.bin.lz4'-$0b
?fileorg =  $c000-?filesize
	.print "File size ",   ?filesize
	.print "File origin ", ?fileorg

	org ?fileorg
source	ins "REHARDEN-$0200-$BFFF-Fix.bin.lz4",+$0b
	.endp

	org $100


	.proc start
	icl "LZ4.asm"

main	sei
	ldx #0
	stx IRQEN
	stx NMIEN
	stx $19
;	mwa #$0200 unlz4.dest		;Save 2 bytes
	stx unlz4.dest
	mva #>$0200 unlz4.dest+1
	mwa #init_0200.source unlz4.source
	jsr unlz4			;Does not change X

;	lda #$7c
wait	lda $d40b
	bne wait
	mwa #$8450 DLISTL		;Restore original DL at $8450
	sta CHBASE
	lda #$fe
	sta PORTB
copy	lda $700,x
	sta $bf00,x
	inx
	bne copy
	inx
	stx $18
	mva #4 $15
	jmp $9db6
critical_end
	.endp

	run start.main

