// dla zachowania kompatybilnosci CPU 6502/65C02/65816 nie uzywamy INC NMIEN / DEC NMIEN

;	@com.wudsn.ide.asm.mainsourcefile=DRAGON.asm

	.proc DetectCPU	;OUT: <A>
;(*
; How to detect on which CPU the assembler code is running
;
; (This information is from Draco, the author of SYSINFO 2.0)
;
; You can test on plain 6502-Code if there is a 65c816 CPU, the 16-Bit processor avaible
; in some XLs as a turbo-board, avaible. Draco told me how to do this:
;
; First we make sure, whether we are running on NMOS-CPU (6502) or CMOS (65c02,65c816).
; I will just show the "official" way which doesn`t uses "illegal opcodes":
;
; result in regA:
; $00 - 6502
; $01 - 65c02
; $80 - 65816
;*)

	opt c+

;detekcja zainstalowanego procesora
	lda #$99
	clc
	sed
	adc #$01
	cld
	beq DetectCPU_CMOS

DetectCPU_02
	lda #0
	jmp stop

DetectCPU_CMOS
	lda #0
	rep #%00000010		;wyzerowanie bitu Z
	bne DetectCPU_C816

DetectCPU_C02
	lda #1
	jmp stop

DetectCPU_C816
	lda #$80

stop
	opt c-

	rts
	.endp


	.proc DetectCPUSpeed ;OUT: clkm>

	tsx
	stx	stk

	lda	vvblki
	sta	lvbl

	lda	vvblki+1
	sta	hvbl

	sei

	ldx	<stop2
	ldy	>stop2

bogo2	lda	vcount
	cmp	#112
	bne	bogo2

	stx	vvblki
	sty	vvblki+1

	lda	#$00
	tax
	tay

	sta	wsync

loop2	iny
	bne	loop2
	inx
	bne	loop2
	clc
	adc	#$01
	bne	loop2
	jmp *
stop2
	pla
	sta	clkm
	pla
	sta	clkm+1
	pla
 	sta	clkm+2

	ldx	#0
stk	equ *-1
	txs

	lda	#0
lvbl	equ *-1
	sta vvblki

	lda	#0
hvbl	equ *-1
	sta vvblki+1

	cli

	rts

clkm	.byte 0,0,0
	.endp


;	.proc DetectHighMem	;OUT: 
;// http://atariki.krap.pl/index.php/Obliczenie_rozmiaru_pami%C4%99ci_liniowej
;
;	.var Result .word
;	.var adr .word
;
;bcnt	= Result
;bfirst	= Result+1
;
;	opt c+
;
;	sei
;	inc nmien
;
;ramsize	stz adr
;	stz adr+1
;	lda #$01
;	sta adr+2
;
;	stz bfirst
;	stz bcnt
;
;?lp0	stz.w $0000
;
;	lda [adr]
;	eor #$ff
;	sta [adr]
;	cmp [adr]
;	bne ?nx
;	ldx.w $0000
;	bne ?nx
;	eor #$ff
;	sta [adr]
;	bra ?fnd
;
;?nx	inc adr+2
;	bne ?lp0
;
;	bra ?abt
;
;?fnd	lda adr+2
;	sta bfirst
;
;	inc adr+2
;	inc bcnt
;
;?lp1	stz.w $0000
;
;	lda [adr]
;	eor #$ff
;	sta [adr]
;	cmp [adr]
;	bne ?abt
;	ldx.w $0000
;	bne ?abt
;	eor #$ff
;	sta [adr]
;	inc bcnt
;	inc adr+2
;	bne ?lp1
;
;        dec bcnt
;
;?abt
;	dec nmien
;	cli
;	rts
;
;	opt c-
;	.endp


